// OverrideSettingsDialog.cpp : implementation file
//

#include "stdafx.h"

#include "P3PClient.h"
#include "P3PObject.h"
#include "OverrideSettingsDialog.h"
#include "P3PPreferences.h"
#include "commctrl.h"
#include "Globals.h"
#include "OverrideSitesDialog.h"


/////////////////////////////////////////////////////////////////////////////
// COverrideSettingsDialog dialog

static DWORD help_array[] = {
							IDC_GROUP_OVERRIDESETTINGS, IDH_GROUP_OVERRIDESETTINGS,
							IDC_SITESETTINGS_DEFAULT, IDH_SITESETTINGS_DEFAULT,
							IDC_SITESETTINGS_NEVER, IDH_SITESETTINGS_NEVER,
							IDC_SITESETTINGS_THIS_SESSION, IDH_SITESETTINGS_THIS_SESSION,
							IDC_SITESETTINGS_ALWAYS, IDH_SITESETTINGS_ALWAYS,
							0,0
						};



COverrideSettingsDialog::COverrideSettingsDialog(GURL URL) 
{
	// Store the pointer to the CP3PObject class

	domain = URL.mindomain();
}


COverrideSettingsDialog::~COverrideSettingsDialog()
{
}


LRESULT COverrideSettingsDialog::OnInitDialog(UINT uMsg, WPARAM wParam, 
	LPARAM lParam, BOOL& bHandled)
{
	if( GPosition pos = g_p3p_preferences.domain_prefs.contains(domain) )
	{
		switch (g_p3p_preferences.domain_prefs[pos])
		{
			case P3PPreferences::ALWAYS :
				CheckDlgButton(IDC_SITESETTINGS_ALWAYS, BST_CHECKED); break;

			case P3PPreferences::THIS_SESSION :
				CheckDlgButton(IDC_SITESETTINGS_THIS_SESSION, BST_CHECKED); break;

			case P3PPreferences::NEVER :
				CheckDlgButton(IDC_SITESETTINGS_NEVER, BST_CHECKED); break;
			
			default:
				CheckDlgButton(IDC_SITESETTINGS_DEFAULT, BST_CHECKED); break;

		}
	}
	else
		CheckDlgButton(IDC_SITESETTINGS_DEFAULT, BST_CHECKED);


	GString window_title = "Cookie Settings for : " + domain;
	SetWindowText((const char*) window_title);

	return 1;  
}


/////////////////////////////////////////////////////////////////////////////
// OnDestroy - Responds to the WM_DESTROY message
// 
LRESULT COverrideSettingsDialog::OnDestroy(UINT, WPARAM, LPARAM, BOOL&)
{

	return 1;  
}


LRESULT COverrideSettingsDialog::OnOK(WORD, WORD, HWND, BOOL&)
{
	GPosition pos = g_p3p_preferences.domain_prefs.contains(domain);

	int save_prefs = -1;
	if( pos )
	{
		save_prefs = g_p3p_preferences.domain_prefs[pos];

		if (IsDlgButtonChecked(IDC_SITESETTINGS_DEFAULT) == BST_CHECKED)
		{
			g_p3p_preferences.domain_prefs.del(pos) ;

			g_p3p_preferences.CookieSave(g_dllpath+COOKIE_FILE);
		//	SendCommandToAllP3Ps(ID_CHANGED_COOKIE_SETTINGS);
			EndDialog(IDOK);
			return 1;
		}
	}

	if (IsDlgButtonChecked(IDC_SITESETTINGS_ALWAYS) == BST_CHECKED)
	{
		g_p3p_preferences.domain_prefs[domain] = P3PPreferences::ALWAYS;
	}
	else if (IsDlgButtonChecked(IDC_SITESETTINGS_THIS_SESSION) == BST_CHECKED)
	{
		g_p3p_preferences.domain_prefs[domain] = P3PPreferences::THIS_SESSION;
	} 
	else if (IsDlgButtonChecked(IDC_SITESETTINGS_NEVER) == BST_CHECKED)
	{
		g_p3p_preferences.domain_prefs[domain] = P3PPreferences::NEVER;
	} 

	if( g_p3p_preferences.domain_prefs.contains(domain) )
	{
		if( g_p3p_preferences.domain_prefs[domain] != save_prefs )
		{
			g_p3p_preferences.CookieSave(g_dllpath+COOKIE_FILE);
		//	SendCommandToAllP3Ps(ID_CHANGED_COOKIE_SETTINGS);
		}
	}

	EndDialog(IDOK);
	return 1;

}

LRESULT COverrideSettingsDialog::OnCancel(WORD, WORD, HWND, BOOL&)
{
	EndDialog(IDCANCEL);
	return 1;

}

LRESULT COverrideSettingsDialog::OnContextHelp(UINT id, WPARAM wParam, LPARAM lParam, BOOL& bFlag)
{
	HELPINFO* pHelpInfo = (LPHELPINFO) lParam;
	
	if (pHelpInfo->iContextType == HELPINFO_WINDOW)
	{
		return HtmlHelp( (HWND)pHelpInfo->hItemHandle, g_dllpath+"\\p3pclient.chm::/ContextSensitiveHelp.txt",
				HH_TP_HELP_WM_HELP, (DWORD)(LPVOID)help_array)  != NULL;
	}
	return 1;

}

LRESULT COverrideSettingsDialog::OnHelp(WORD, WORD, HWND, BOOL&)
{
	return HtmlHelp( NULL, g_dllpath+"\\p3pclient.chm::/help-overridecookiesettings.html",
				HH_DISPLAY_TOPIC, 0)  != NULL;

}

LRESULT COverrideSettingsDialog::OnCookieOverrideSites(WORD, WORD, HWND, BOOL&)
{
	EndDialog(IDOK);
	COverrideSitesDialog osd;
	osd.DoModal();
	return 1;
}






