// P3PClient.cpp : Implementation of DLL Exports.


// Note: Proxy/Stub Information
//      To build a separate proxy/stub DLL, 
//      run nmake -f P3PClientps.mk in the project directory.

#include "stdafx.h"
#include "resource.h"
#include <initguid.h>
#include "P3PClient.h"
#include "P3PClient_i.c"
#include "P3PObject.h"
#include "Globals.h"
#include "GOS.h"
#include "P3PPreferences.h"
#include "PrivacySettingsDialog.h"
#include "OtherSettingsDialog.h"
#include "WebHost.h"
#include "PatMatch.h"

#pragma comment (lib, "shlwapi.lib")

CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_P3PObject, CP3PObject)
	OBJECT_ENTRY(CLSID_WebHost, CWebHost)
END_OBJECT_MAP()

/////////////////////////////////////////////////////////////////////////////
// DLL Entry Point

#define BITMAP_UNKNOWN	IDB_BIRDUNKNOWN
#define BITMAP_MATCH	IDB_BIRDMATCH
#define BITMAP_NOMATCH	IDB_BIRDNOMATCH
#define BITMAP_DISABLE	IDB_BIRDDISABLE

void LoadCookieman();


extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
		// Check who's loading us. 
		// If it's Explorer then "no thanks" and exit...
		TCHAR pszLoader[MAX_PATH];
		GetModuleFileName(NULL, pszLoader, MAX_PATH);
		_tcslwr(pszLoader);
		if (_tcsstr(pszLoader, _T("explorer.exe"))) 
			return FALSE;

		// ATL initialization
        _Module.Init(ObjectMap, hInstance, &LIBID_P3PClientLib);
        DisableThreadLibraryCalls(hInstance);

		hinst=hInstance;
		char path[2049];
		GetModuleFileName(hInstance, path, 2048 );
		/*for(int i=0; i<64; i++)
			LoadLibrary(path);*/

		TRY
		{
			g_dllpath = GOS::dirname(path);

			InitializeXmlParserFunctions(g_dllpath+"\\expat.dll");
			g_p3p_preferences.Load();
		}
		CATCH(ex)
		{}
		ENDCATCH;

#ifdef COOKIES
		LoadCookieman();
#endif
		

    }
    else if (dwReason == DLL_PROCESS_DETACH)
	{
        _Module.Term();
	}
    return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Used to determine whether the DLL can be unloaded by OLE

STDAPI DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

/////////////////////////////////////////////////////////////////////////////
// Returns a class factory to create an object of the requested type

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

/////////////////////////////////////////////////////////////////////////////
// DllRegisterServer - Adds entries to the system registry

STDAPI DllRegisterServer(void)
{
    // registers object, typelib and all interfaces in typelib
    return _Module.RegisterServer(TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    return _Module.UnregisterServer(TRUE);
}

STDAPI InstallDisplaySettings()
{
	CPrivacySettingsDialog psd;
	psd.DoModal();
	COtherSettingsDialog osd;
	osd.DoModal();

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
///-------***--*******************************************************////
///--****--**--****--*************************************************////
///--****--**--****--*************************************************////
///------****--******************************************************////
///--********--*******************************************************////
///--********--*******************************************************////
//////////////////////////////////////////////////////////////////////////



int _stdcall GetThreadDataFromBHO(DWORD threadID, char *jar, char *url)
{
	CP3PObject *p3p = CP3PObject::GetP3PObjectForThread(threadID);
	if( p3p )
	{
		strcpy(jar, "Role1");
		GURL gurl = p3p->locationURL;
		TRY
		{
			if( !gurl.is_empty() && gurl != GURL(url))
			{
				strcpy(url, gurl);
			}
		}
		CATCH(ex)
		{
		}
		ENDCATCH;
		return S_OK;
	}
	return  S_FALSE;
}

void GetCookieNameValue(const char *cookie_data, GString &name, GString &value, int *length=0)
{
	if( cookie_data )
	{
		char *equal = strchr(cookie_data, '=');
		if( equal )
		{
			name = GString(cookie_data, 0, equal-cookie_data);
			char *semicolon = strchr(equal, ';');
			if( semicolon )
			{
				value = GString(equal+1, 0, semicolon-(equal+1) );
				if( length )
					*length = semicolon - cookie_data;
			}
			else
			{
				value = GString(equal+1);
				if( length )
					*length = strlen(cookie_data);
			}
		}
		else
		{
			name = cookie_data;
			value = "";
			if( length )
					*length = strlen(cookie_data);
		}
	}
	else
	{
		name = "";
		value = "";
		if( length )
			*length = 0;
	}
}



int _stdcall  InformCookieEventToBHO(DWORD threadID, BOOL
							bCookieRecieved, char* cookies_data, BOOL* should_jam, 
							BOOL bIsTracker, char *TrackerDomain, char* SiteDomain)
{
//	*should_jam = TRUE;
	if( !cookies_data && should_jam)
	{
		*should_jam = FALSE;
		return S_OK;
	}

	if( bCookieRecieved )
	{
		///receiving cookie	
		if( cookies_data && strlen(cookies_data) )
		{
			CP3PObject *p3p = CP3PObject::GetP3PObjectForThread(threadID);
			if( p3p )
			{	
				GString name, value;
				GetCookieNameValue(cookies_data, name, value);
				if( p3p->AddCookie(name, value, SiteDomain, TrackerDomain, "") )
				{
					//block the cookie
					/*int len = strlen(cookies_data);
					memset(cookies_data, ' ', len);
					*/
					if( should_jam )
						*should_jam = TRUE;
					else 
						return S_FALSE;
				}
				else
				{
					if( should_jam )
						*should_jam = FALSE;
					else 
						return S_FALSE;
				}
			}
			else
			{
				/*int len = strlen(cookies_data);
				memset(cookies_data, ' ', len);*/
				if( should_jam )
						*should_jam = TRUE;
				else 
					return S_FALSE;
			}
		}
	}
	else
	{
		///sending cookie
		/// check cookie prefs for the site
		if( cookies_data && strlen(cookies_data))
		{
			CP3PObject *p3p = CP3PObject::GetP3PObjectForThread(threadID);
			if( p3p )
			{
				char *data = cookies_data;
				if( strstr(cookies_data, "Cookie: ") )
					data += 8;
				int length;
				do
				{
					GString name, value;
					GetCookieNameValue(data, name, value, &length);
					if( length && p3p->NeedCookieBlocking(name, value, SiteDomain, TrackerDomain, "") )
					{
						memset(data, ' ', length);
						
					}
					data += length;
					while(*data && (*data == ';'||isspace(*data)) )
						data++;
				}
				while(*data && length);
			}
			else
			{
				int len = strlen(cookies_data);
				memset(cookies_data, ' ', len);
			}
			
		}
	}
		
	return S_OK;
}

int _stdcall  InformRedirectionToBHO(DWORD threadID, char *OriginURL, char *RedirectedURL, char * NewJarName)
{
	CP3PObject *p3p = CP3PObject::GetP3PObjectForThread(threadID);
	if( p3p )
	{
		p3p->InformRedirection(OriginURL, RedirectedURL);
		return S_OK;
	}
	return S_FALSE;
}


int _stdcall  GetURLSensitivityFromBHO(DWORD threadID, int *Sensitivity)
{
	*Sensitivity = 0;
	return S_OK;
}

double GetIEVersion()
{
	HKEY hSectionKey = NULL;
	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\Microsoft\\Internet Explorer", 0, 
		           KEY_READ, &hSectionKey) == ERROR_SUCCESS )
    {
		char szValue[50];
		DWORD dwType=0;
		DWORD dwCount = sizeof(szValue);
		LONG lResult = RegQueryValueEx(hSectionKey, "Version", NULL, 
									   &dwType, (LPBYTE)szValue, &dwCount);
		RegCloseKey(hSectionKey);
		if (lResult==ERROR_SUCCESS && dwType==REG_SZ )
		{
			GString Value = szValue;
			if( Value >= "4.72.2106.8" && Value <= "4.72.3612.1713")
				return 4.01;
			else if( Value >= "5.00.0518.10" && Value <= "5.00.2614.3500")
				return 5;
			else if( Value >= "5.00.29" && Value < "5.5")
				return 5.01; 
			else if( Value >= "5.5" && Value < "6.0" )
				return 5.5;
			else if( Value > "6.0" )
				return 6.0;
		}
    }
	return 0;
}




void LoadCookieman()
{
	double IEVersion = GetIEVersion();
	if( IEVersion >= 4.01 && IEVersion < 6.0 )
	{
		

		HMODULE cookiemodule = 0;
		cookiemodule = LoadLibrary(g_dllpath+"\\CookieMan.dll");
		if( cookiemodule )
		{
			CM_RegisterBho = (TCM_RegisterBho*)GetProcAddress(cookiemodule, "CM_RegisterBho");
			CM_UnregisterBho = (TCM_UnregisterBho*)GetProcAddress(cookiemodule, "CM_UnregisterBho");
			CM_UpdateTrackersBlackList = (TCM_UpdateTrackersBlackList*)GetProcAddress(cookiemodule, "CM_UpdateTrackersBlackList");
			CM_EnableIDcide = (TCM_EnableIDcide*)GetProcAddress(cookiemodule, "CM_EnableIDcide");
			CM_CleanRequests = (TCM_CleanRequests*)GetProcAddress(cookiemodule, "CM_CleanRequests");
			CM_GetProxySettings = (TCM_GetProxySettings*)GetProcAddress(cookiemodule, "CM_GetProxySettings");
			
			if( CM_RegisterBho )
				CM_RegisterBho(GetThreadDataFromBHO, InformCookieEventToBHO, InformRedirectionToBHO, GetURLSensitivityFromBHO);

		}
	}
}


