// PostWarningDialog.cpp : implementation file
//

#include "stdafx.h"

#include "P3PClient.h"
#include "P3PObject.h"
#include "PostWarningDialog.h"
#include "commctrl.h"
#include "PolicySummaryDialog.h"
#include "P3PPreferences.h"
#include "Globals.h"

#define PRIVACY_NOTMATCH_STRING		"The privacy policy of this form does not match your preferences."
#define PRIVACY_NOTFOUND_STRING		"No privacy policy can be found for this form."



/////////////////////////////////////////////////////////////////////////////
// CPostWarningDialog dialog


CPostWarningDialog::CPostWarningDialog(Result *res): result(res), font(0), dontwarn(false)
{
	// Store the pointer to the CP3PObject class
}


CPostWarningDialog::~CPostWarningDialog()
{
}


LRESULT CPostWarningDialog::OnInitDialog(UINT uMsg, WPARAM wParam, 
	LPARAM lParam, BOOL& bHandled)
{
	
	::ShowWindow(GetDlgItem(IDC_MOREINFO), result?SW_SHOW:SW_HIDE);
	font = CreateFont(16, 0, 0, 0, FW_BOLD, TRUE, FALSE, FALSE, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH, "arial");

	

	return 1;  
}


LRESULT CPostWarningDialog::OnPaint(UINT, WPARAM, LPARAM, BOOL&)
{
	
	PAINTSTRUCT paintStruct;
	HDC hdc = BeginPaint(&paintStruct);
	HFONT oldfont = (HFONT)SelectObject(hdc, font);
	GString displayStr = PRIVACY_NOTFOUND_STRING;
	if( result )
		displayStr = PRIVACY_NOTMATCH_STRING;

	//FOR SCREEN-READER ACCESSIBILITY
	SetDlgItemText(IDC_STATIC_POSTWARNING, displayStr);	 

	RECT rect;
	GetClientRect(&rect);
	rect.left += 10;
	rect.top += 10;
	int oldbkmode = SetBkMode(hdc,TRANSPARENT); 
	DrawText(hdc, displayStr, displayStr.length(), &rect, DT_SINGLELINE);
	SetBkMode(hdc, oldbkmode);
	SelectObject(hdc, oldfont);
	EndPaint(&paintStruct );

		
	return 0;
}


/////////////////////////////////////////////////////////////////////////////
// OnDestroy - Responds to the WM_DESTROY message
// 
LRESULT CPostWarningDialog::OnDestroy(UINT, WPARAM, LPARAM, BOOL&)
{

	return 1;  
}


LRESULT CPostWarningDialog::OnOK(WORD, WORD, HWND, BOOL&)
{

	dontwarn = IsDlgButtonChecked(IDC_WARNME)==BST_CHECKED?true:false;
	bool dontwarn_allsites = IsDlgButtonChecked(IDC_WARNME_ALLSITES)==BST_CHECKED?true:false;

	if( g_p3p_preferences.GetNoPromptAllForms() != dontwarn_allsites )
	{
		g_p3p_preferences.SetNoPromptAllForms(dontwarn_allsites);
	}
	EndDialog(IDOK);
	return 1;

}
LRESULT CPostWarningDialog::OnCancel(WORD, WORD, HWND, BOOL&)
{
	dontwarn = IsDlgButtonChecked(IDC_WARNME)==BST_CHECKED?true:false;
	bool dontwarn_allsites = IsDlgButtonChecked(IDC_WARNME_ALLSITES)==BST_CHECKED?true:false;

	if( g_p3p_preferences.GetNoPromptAllForms() != dontwarn_allsites )
	{
		g_p3p_preferences.SetNoPromptAllForms(dontwarn_allsites);
	}
	EndDialog(IDCANCEL);
	return 1;

}

LRESULT CPostWarningDialog::OnMoreInfo(WORD, WORD, HWND, BOOL&)
{
	if( result )
	{
		CPolicySummaryDialog psd(*result);
		psd.DoModal();
	}
	return 1;
}

LRESULT CPostWarningDialog::OnContextHelp(UINT id, WPARAM wParam, LPARAM lParam, BOOL& bFlag)
{
	::MessageBeep(MB_OK);
	return 1;
}



