#ifndef __PrivacySettingsDLG_H_
#define __PrivacySettingsDLG_H_

#include "resource.h"       // main symbols
#include <atlhost.h>
#include "P3PPreferences.h"


/////////////////////////////////////////////////////////////////////////////
// CPrivacySettingsDialog dialog

class CPrivacySettingsDialog : public CAxDialogImpl<CPrivacySettingsDialog>
{
// Construction
public:
	CPrivacySettingsDialog();   // standard constructor

	~CPrivacySettingsDialog();

	enum { IDD = IDD_PRIVACYSETTINGS };

BEGIN_MSG_MAP(CPrivacySettingsDialog)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	MESSAGE_HANDLER(WM_DESTROY, OnDestroy)
	MESSAGE_HANDLER(WM_HELP, OnContextHelp)
	COMMAND_ID_HANDLER(IDOK, OnOK)
	COMMAND_ID_HANDLER(IDCANCEL, OnCancel)
	COMMAND_HANDLER(IDC_EXPORT, BN_CLICKED, OnClickedExport)
	COMMAND_HANDLER(IDC_IMPORT, BN_CLICKED, OnClickedImport)
//	COMMAND_HANDLER(IDC_PRIVACY_LEVEL, CBN_SELCHANGE, OnSelchangePrivacyLevel)
	COMMAND_HANDLER(IDC_LOW_PRIVACY, BN_CLICKED, OnClickedLowPrivacy)
	COMMAND_HANDLER(IDC_MEDIUM_PRIVACY, BN_CLICKED, OnClickedMediumPrivacy)
	COMMAND_HANDLER(IDC_HIGH_PRIVACY, BN_CLICKED, OnClickedHighPrivacy)
	COMMAND_HANDLER(IDC_CUSTOM_PRIVACY, BN_CLICKED, OnClickedCustomPrivacy)
	COMMAND_HANDLER(IDC_IMPORTED_PRIVACY, BN_CLICKED, OnClickedImportedPrivacy)

	COMMAND_HANDLER(IDC_MEDICAL_ANALYSIS, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_HANDLER(IDC_MEDICAL_SHARE, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_HANDLER(IDC_FINANCIAL_ANALYSIS, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_HANDLER(IDC_FINANCIAL_SHARE, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_HANDLER(IDC_CONTACT_PHONE, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_HANDLER(IDC_CONTACT_MAIL, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_HANDLER(IDC_NO_REMOVE_MAILINGLIST, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_HANDLER(IDC_PERSONAL_ANALYSIS, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_HANDLER(IDC_PERSONAL_SHARE, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_HANDLER(IDC_NO_ACCESS_DATA, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_HANDLER(IDC_NONPERSONAL_ANALYSIS, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_HANDLER(IDC_NONPERSONAL_SHARE, BN_CLICKED, OnClickedAnyWarning)
	COMMAND_ID_HANDLER(IDC_MYHELP, OnHelp)
END_MSG_MAP()

	LRESULT OnInitDialog(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnDestroy(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnOK(WORD, WORD, HWND, BOOL&);
	LRESULT OnCancel(WORD, WORD, HWND, BOOL&);
	LRESULT OnContextHelp(UINT, WPARAM, LPARAM, BOOL&);
	LRESULT OnClickedExport(WORD wNotifyCode, WORD wID, HWND hwnd, BOOL& bHandled);
	LRESULT OnClickedImport(WORD wNotifyCode, WORD wID, HWND hwnd, BOOL& bHandled);
//	LRESULT OnSelchangePrivacyLevel(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnHelp(WORD, WORD, HWND, BOOL&);

	int InitWarnings();

private:
	bool isImported;
/*	int save_privacy_level;
	bool save_warn_personal, save_warn_medical, save_warn_financial;
	bool save_warn_nonpersonal_research, save_warn_nonpersonal_decide_content, save_warn_nonpersonal_share_thirdparty;
	bool save_warn_personal_research, save_warn_personal_decide_content, save_warn_personal_contact_mail;
	bool save_warn_personal_contact_phone, save_warn_personal_share_thirdparty;
	bool save_warn_no_remove_mailinglist, save_warn_no_access_data;
*/
	P3PPreferences save_settings;
	int ValidAppelFile(const char* filename);

	LRESULT OnClickedLowPrivacy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedMediumPrivacy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedHighPrivacy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedCustomPrivacy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedImportedPrivacy(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	LRESULT OnClickedAnyWarning(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
};


#endif 