// WebHost.cpp : Implementation of CWebHost

#include "stdafx.h"
#include "P3PClient.h"
#include "WebHost.h"
#include <stdio.h>
#include "globals.h"
#include "SummaryHTML.h"






LRESULT CWebHost::OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	CAxWindow wnd(m_hWnd);
	HRESULT hr = wnd.CreateControl(IDH_WEBHOST);

	if (SUCCEEDED(hr))
		hr = wnd.SetExternalDispatch(static_cast<IWebHostUI*>(this));

	if ( SUCCEEDED(hr))
		hr = wnd.QueryControl(IID_IWebBrowser2, (void**)&m_spBrowser);

	/*if( SUCCEEDED(hr) )
		m_spBrowser->GoHome();*/

	return SUCCEEDED(hr) ? 0 : -1;
}


STDMETHODIMP CWebHost::Run(HWND parent, const char *contentpath)
{
	if( !parent )
		return E_FAIL;

	RECT rcClient;
	::GetClientRect(parent, &rcClient);
	rcClient.left += MARGIN;
	rcClient.right -= MARGIN;
	rcClient.top += MARGIN;
	rcClient.bottom -= MARGIN;
	
	if( Create(parent, rcClient, _T("Hai"), WS_VISIBLE|WS_CHILD|WS_VSCROLL, 0, (UINT)NULL) == NULL )
	{
		return E_FAIL;
	}

	ShowWindow(SW_SHOWNORMAL);
	CComBSTR bstrurl(contentpath);

	
	CComVariant vtEmpty;
	m_spBrowser->Navigate(bstrurl, &vtEmpty, &vtEmpty, &vtEmpty, &vtEmpty);
	return S_OK;
}


STDMETHODIMP CWebHost::Run(HWND parent, Result &result)
{
	GString resulthtml;
	SummaryHTML::PrepareSummaryHTML(result, resulthtml);
	///save the summary
	// Store the pointer to the CP3PObject class
	char *tname = tempnam(g_dllpath, "summary");
	if( tname )
	{
		summaryfilename = tname;
	}
	else
	{
		summaryfilename += g_dllpath+"\\summary";
	}
	summaryfilename += ".html";

	{
		FILE *fp;
		if( fp = fopen(summaryfilename, "wb") )
		{
			fwrite(resulthtml, resulthtml.length(), 1, fp);
			fclose(fp);
		}
		else
			return E_FAIL;
	}

	return Run(parent, summaryfilename);

}

CWebHost::~CWebHost()
{
	if( summaryfilename.length() )
		unlink(summaryfilename);
}

/////////////////////////////////////////////////////////////////////////////
// CWebHost

